# DonkiWeb
<table><tr>
<td><img src="etc/html/images/DonkiWeb.png" title="donkiWeb" width=100></td>
<td><b>DonkiWeb</b> is a Python/Javascript SCADA for creating Tango Web GUIs.</td>
</tr></table>
 An intuitive API allows to create Web interfaces with few lines of code, little Javascript knowledge required.

<img src="screenshots/Screenshot_scripting.png" title="donkiWeb"><br>

# Behind the scenes
- Bottle Web Framework (Python backend) 
- Litegui.js widget library (Javascript frontend)
- Embedded Tango REST server
- Custom GUI API JS library
- Embedded websocket server for data update
- SVG widgets for colorful elements

# DonkiWeb GUI short description
Each web GUI consists in a HTML file that imports a specific Javascript code (examples in `etc/html/demo`).
DonkiWeb API methods allow to organize visual widgets in grids inside containers (tab container available). Each web page hosts a single or multiple panels. Default “look & feel” in a CSS file. API methods are contained in: `etc/html/donkiweb_lib/donkiweb_lib.js`

![donkiWeb Demo](screenshots/Screenshot_playground.png)

# DonkiWeb synoptics
DonkiWeb API allows to easily create web synoptics: synoptic elements are aligned in rows, their core element is a SVG image containing a specific object tag for color changes.

![donkiWeb Synoptic](screenshots/Screenshot_Synoptic.png)

# TANGO control system
DonkiWeb includes a Tango REST web interface (JSON based protocol). An alternative “Astor/Jive” web application allows an easy interaction with any Tango device:<b>
`etc/html/demo/donkiweb_tangotree.js`
<table><tr>
<td><img src="screenshots/Screenshot_Jive.png" title="donkiWeb Jive">DonkiWeb Jive</td>
<td><img src="screenshots/Screenshot_Astor.png" title="donkiWeb Astor">DonkiWeb Astor</td>
</tr></table>

# User authentication
The DonkiWeb web server allows to restrict:
- web pages access;
- write operations and commands on the control system.

Authentication rules, contained in a configuration file, can be defined as:
- list of static “username/password” tuples;
- list of trusted IP addesses;
- list of VUO users (Elettra authentication service).
