page_title = 'DonkiWeb DEMO';
stream_info = "WS:8090";

function populateMyArea( mainarea )
{
    var myPanel = new LiteGUI.Panel("first_panel", {title:page_title, close:true,scroll:true});
    mainarea.add( myPanel );
    var aInsp = donkiAddInspector(myPanel, {widgets_per_row: 3});
    //
    donkiAddLabel(aInsp, "Boolean Scalar", {width: 150, align: "right"});
    donkiAddReadSVG(aInsp, "ebl-control-01.blcs.elettra.trieste.it:20000/sys/tg_test/1/boolean_scalar", {size: 14});
    var aBCtrl=donkiAddBoolControl(aInsp, null,"ebl-control-01.blcs.elettra.trieste.it:20000/sys/tg_test/1/boolean_scalar",["Falso","Vero"],{width: 140, confirm:true});
    donkiAddDisableManager(aBCtrl,"ebl-control-01.blcs.elettra.trieste.it:20000/sys/tg_test/1/boolean_scalar",[false]);
    //donkiAddBoolControl(aInsp, null,"twinmic-control-01.esce.elettra.trieste.it:20000/sys/tg_test/1/boolean_scalar",["Yes","No"],{width: 140, confirm:true});
    donkiAddLineBreak(aInsp);
    donkiAddLabel(aInsp, "Double Scalar", {width: 150, align: "right"});
    donkiAddReadLabel(aInsp, "ebl-control-01.blcs.elettra.trieste.it:20000/sys/tg_test/1/double_scalar", {width: 100});
    donkiAddLineBreak(aInsp);
    donkiAddCheckBox(aInsp, "ebl-control-01.blcs.elettra.trieste.it:20000/sys/tg_test/1/boolean_scalar", {size: 140});
    donkiAddLineBreak(aInsp);
    donkiAddReadTextArea(aInsp, "ebl-control-01.blcs.elettra.trieste.it:20000/sys/tg_test/1/wave", {height:100, width: 200});
    donkiAddReadTextArea(aInsp, "ebl-control-01.blcs.elettra.trieste.it:20000/twinmic/daq/executer/StepByStepLog", {height:100, width: 300, reverse:true});
    //
    donkiAddLineBreak(aInsp);
    donkiAddPositionManager(aInsp, "double_scalar","ebl-control-01.blcs.elettra.trieste.it:20000/sys/tg_test/1/double_scalar_w");
    donkiAddLineBreak(aInsp);
    donkiAddLabel(aInsp, null, {width: 180, align: "center"});
    var voidBtn = donkiAddCommandButton(aInsp, "VOID","ebl-control-01.blcs.elettra.trieste.it:20000/sys/tg_test/1/DevVoid",{width: 100, confirm: true});
    donkiAddDisableManager(voidBtn,"ebl-control-01.blcs.elettra.trieste.it:20000/sys/tg_test/1/boolean_scalar",[false]);
    //
	mainarea.split("vertical",["400px", null],true);
	var bottom_panel = new LiteGUI.Panel({ id: "bottom_panel", title:"Synoptic panel",close:true});
	mainarea.getSection(1).add( bottom_panel );
    //
	mainarea.getSection(0).split("horizontal",[null,600],true);
	var rightPanel = new LiteGUI.Panel("right_panel", {title:'Right panel', close: true});
	mainarea.getSection(0).getSection(1).add( rightPanel );
    //
    var rInsp = donkiAddInspector(rightPanel, {widgets_per_row: 3});
    donkiAddSection(rInsp, "Line Plot", {collapsed:false});
    x_attr = null;
    //x_attr = "ebl-control-01.blcs.elettra.trieste.it:20000/sys/tg_test/1/double_scalar";
    //y_attr = "ebl-control-01.blcs.elettra.trieste.it:20000/sys/tg_test/1/short_scalar_ro";
    /*
    x_attr = "ebl-control-01.blcs.elettra.trieste.it:20000/sys/tg_test/1/float_spectrum";
    */
    y_attr = "ebl-control-01.blcs.elettra.trieste.it:20000/sys/tg_test/1/wave";
    donkiAddLinePlot(rInsp, "X vs Y", x_attr, y_attr, {width:400, height:250, chart_size:100})
    //
    var sInsp = donkiAddInspector(bottom_panel, {widgets_per_row: 3});
    var aSyn = donkiAddSynopticContainer(sInsp);
    std_options = {width:60, height:60, lut: lut_VALVE};
    valve_options = {width:60, height:60, lut: lut_VALVE, readonly: false};
    //
    attrname = "ebl-control-01.blcs.elettra.trieste.it:20000/sys/tg_test/1/boolean_scalar";
    colorattr = "ebl-control-01.blcs.elettra.trieste.it:20000/sys/tg_test/1/boolean_scalar";
    alarmattr = "ebl-control-01.blcs.elettra.trieste.it:20000/sys/tg_test/1/boolean_scalar";
    readattrs = ["ebl-control-01.blcs.elettra.trieste.it:20000/sys/tg_test/1/double_scalar", "ebl-control-01.blcs.elettra.trieste.it:20000/sys/tg_test/1/ulong_scalar"];
    donkiAddSynopticElement(aSyn, '/html/synoptic_images/donkiweb_shutter.svg','Shutter',colorattr,alarmattr,readattrs,valve_options);
    donkiAddSynopticElement(aSyn, '/html/synoptic_images/donkiweb_stopper.svg','Stopper',colorattr,alarmattr,readattrs,std_options);
    donkiAddSynopticElement(aSyn, '/html/synoptic_images/donkiweb_valve.svg','Last Valve',colorattr,alarmattr,readattrs,valve_options);
    donkiAddSynopticElement(aSyn, '/html/synoptic_images/donkiweb_monochromator.svg','Monochromator','','',readattrs,std_options);
    donkiAddSynopticElement(aSyn, '/html/synoptic_images/donkiweb_slits.png','Slits',colorattr,'',readattrs,std_options);
    donkiAddSynopticElement(aSyn, '/html/synoptic_images/donkiweb_valve.svg','Exp. Valve',colorattr,alarmattr,readattrs,valve_options);
    donkiAddSynopticElement(aSyn, '/html/synoptic_images/donkiweb_mirror_bottom.svg','Mirror','','',readattrs,std_options);
    aSyn.show();
    //
    donkiAddLineBreak(aInsp);
    donkiAddLineBreak(aInsp);
    var aGrid = donkiAddGridInspector(myPanel, {});
    donkiAddLabel(aGrid,"CIAO",{row:1,col:1});
    donkiAddImage(aGrid,"/html//images/logo_tango.png", {height:60,row:1,col:2});
    donkiAddPositionManager(aGrid, "double_scalar","ebl-control-01.blcs.elettra.trieste.it:20000/sys/tg_test/1/double_scalar_w",{row:1,col:3});
    donkiAddReadWriteLabel(aGrid, "double_scalar","ebl-control-01.blcs.elettra.trieste.it:20000/sys/tg_test/1/double_scalar_w",{row:2,col:1,col_span:2});
    donkiAddReadLabel(aGrid, "ebl-control-01.blcs.elettra.trieste.it:20000/sys/tg_test/1/double_scalar", {caption: "PIPPO",width: 150,row:2,col:3});
}
