page_title = 'GECO Interlocks DEMO';
stream_info = "POLLING";


function loadFile(filePath) {
    var result = null;
    var xmlhttp = new XMLHttpRequest();
    xmlhttp.open("GET", filePath, false);
    xmlhttp.send();
    if (xmlhttp.status==200) {
        result = xmlhttp.responseText;
    }
    return result;
}

function clearPanel(thePanel, added_elements)
{
    //
    thePanel.clear()
    // Clear dynamically added elements
    for (var j = 0; j < added_elements.length; j++) {
	    past_values[elem_ids[added_elements[j]]] = null;
		delete elem_ids[added_elements[j]];
	}
}

function populateMyArea( mainarea )
{
    //
    if (typeof GECO_TD === "undefined") {
        console.log("GECO_TD not defined!");
        return;
    };
    if (typeof DATA_FILE === "undefined") {
        console.log("DATA_FILE not defined!");
        return;
    };
    mainarea.split("horizontal",["280px", null],true);
    var rightPanel = new LiteGUI.Panel({ id: "right_panel", title:"Iterlock Formula",close:true,scroll:true});
    //
    var leftPanel = new LiteGUI.Panel({ id: "left_panel", title:"Interlock Status",close:true,scroll:true});
    //
    mainarea.getSection(0).add( leftPanel )
    mainarea.getSection(1).add( rightPanel );
    var aInsp = donkiAddInspector(leftPanel, {widgets_per_row: 2});
    //
    var rule_elements = {};
    var dwidgets_added = [];
    //
    function onClick(item) {
        var rule = rule_elements[item];
        clearPanel(rightPanel,dwidgets_added);
        dwidgets_added.length = 0;
        var tInsp = donkiAddInspector(rightPanel);
        let aTitle = donkiAddReadColorLabel(tInsp,GECO_TD+"/"+item+"_INTLCK",item,{color:"white",align:"left",lut:lut_INTLCK});
        aTitle.style.fontSize = "x-large";
		aTitle.setAttribute("onclick", "showGecoInfo('"+item+"');");
		aTitle.style.cursor = "context-menu";
        dwidgets_added.push(aTitle.id);
        past_values[elem_ids[aTitle.id]] = null; 
		donkiAddLineBreak(tInsp);
		donkiAddSeparator(tInsp);
        var gInsp = donkiAddGridInspector(rightPanel);
		var rule_items = rule.split(" ");
		var sub_rule = false;
		var row_idx = 1;
		var col_idx = 1;
		for (var j = 0; j < rule_items.length; j++) {
			rule_item = (rule_items[j]).trim();
			var ifNot = (rule_item.indexOf("NOT(") > -1);
			if (rule_item.indexOf("(") > -1) {
				sub_rule = true;
				rule_item = rule_item.split("(")[1];
			}
			if (rule_item.indexOf(")") > -1) {
				sub_rule = false;
				rule_item = rule_item.split(")")[0];
			}
			if (["SIP","TCS","VGPE"].indexOf(rule_item.split("_")[0]) > -1) {
				let dWidget = donkiAddReadColorLabel(gInsp, GECO_TD+"/"+rule_item+"_ALARM", rule_item, {row:row_idx,col:col_idx,lut:lut_ALARM,color:"white"});
				dWidget.setAttribute("onclick", "showGecoInfo('"+rule_item+"');");
				dWidget.style.cursor = "context-menu";
				dwidgets_added.push(dWidget.id);
			} else if (["AND","OR"].indexOf(rule_item) > -1) {
				let dWidget = donkiAddLabel(gInsp, rule_item, {row:row_idx,col:col_idx});
			} else {
				let lut_to_use = lut_BOOL;
				let text_to_use = rule_item;
				if (ifNot) {
					lut_to_use = lut_VALVE;
					text_to_use = "NOT( "+rule_item+" )";
				}
				let dWidget = donkiAddReadColorLabel(gInsp, GECO_TD+"/"+rule_item, text_to_use, {row:row_idx,col:col_idx,lut:lut_to_use,color:"white"});
				dWidget.setAttribute("onclick", "showGecoInfo('"+rule_item+"');");
				dWidget.style.cursor = "context-menu";
				dwidgets_added.push(dWidget.id);
			}
			if (!(sub_rule)) {
				donkiAddLineBreak(gInsp);
				row_idx = row_idx+ 1;
				col_idx = 1;
			} else {
				col_idx = col_idx + 1;
			}
		}
		update_source_points();
    }
    //
    donkiAddSeparator(aInsp);
    //
    var content = loadFile(DATA_FILE);
    var lines = content.split('\n');
    for (var i = 0; i < lines.length; i++) {
		if (lines[i]) {
			var item = (lines[i].split("|")[0]).trim();
			var rule = (lines[i].split("|")[1]).trim();
			rule_elements[item] = rule;
			aInsp.addButton(null,item,{width:250, callback: onClick });
			donkiAddReadSVG(aInsp, GECO_TD+"/"+item+"_INTLCK", {size:14,lut:lut_INTLCK});
			donkiAddLineBreak(aInsp);
			//donkiAddSeparator(aInsp);
		}
	}
    //
    donkiAddSeparator(aInsp);
    // Add Legend of symbols button
    let slCode = "<b style='font-size:14px;display:block;margin-left:auto;margin-right: auto;'><button onclick='showGecoLegend()' class='litebutton' style='color:cyan;'>Legend of symbols</button></b>";
    let nDiv = document.createElement("div");
    nDiv.className = "container";
    nDiv.style.display = "flex";
    nDiv.style.alignItems = "center";
    nDiv.innerHTML = slCode;
    aInsp.append(nDiv);
}
