var GECO_ELEMENT_DESCR = {
   STP: "Stopper",
   SHT: "Shutter",
   SHP: "Shopper",
   VLV: "Gate Valve",
   FVLV: "Fast Valve",
   SIP: "Ion Pump Alarm",
   VGPE: "Vacuum Gauge Alarm",
   TCS: "Thermocouple Alarm",
   FS: "Water Flow Switch Alarm",
   ABI: "Enablement (Italian: Abilitazione)"
}

var GECO_ZBS = {
   S: "Storage Ring",
   E: "Experimental Hall",
}

var GECO_BL_SECTIONS = {
   F: "Front End",
   B: "Beam Transport",
   L: "Left Branch",
   LL: "Left Left Branch",
   LR: "Left Right Branch",
   LC: "Left Central Branch",
   R: "Right Branch",
   RL: "Right Left Branch",
   RR: "Right Right Branch",
   RC: "Right Central Branch",
   C: "Central Branch",
   CL: "Central Left Branch",
   CR: "Central Right Branch",
   CC: "Central Central Branch"
}


function showGecoLegend() {
    let msg = "<div style='margin:20px;'>";
	msg = msg + "<b><big>GECO Symbols</big></b><br><hr><br>";
	for(value in GECO_ELEMENT_DESCR) {
		if (GECO_ELEMENT_DESCR[value]){
			msg = msg + "<b>"+value+"</b>: "+GECO_ELEMENT_DESCR[value]+"<br>";
		}
	}
	msg = msg + "<br><br></div>";
	LiteGUI.showMessage( msg, {title: "GECO symbols"});
}

function showGecoInfo(item_in) {
	let item_type = item_in.split("_")[0];
    let msg = "<div style='margin:20px;'>";
	if (GECO_ELEMENT_DESCR[item_type]) {
		msg = msg + "<b>Type</b>: "+GECO_ELEMENT_DESCR[item_type]+" ("+item_type+")<br>";
	}
	if (item_in.indexOf("_") > -1) {
		let item_pos = item_in.split("_")[1]
		let zbs_info = item_pos.charAt(0);
		let pos_tokens = item_pos.substring(1, item_pos.indexOf(".")).split("-");
		msg = msg + "<b>Zone</b>: "+GECO_ZBS[zbs_info]+"<br>";
		if (pos_tokens.length > 1) {
			msg = msg + "<b>Beamline</b>: "+pos_tokens[0]+"."+pos_tokens[1]+"<br>";
		}
		if (pos_tokens.length > 2) {
			msg = msg + "<b>Section</b>: "+GECO_BL_SECTIONS[pos_tokens[2]]+"<br>";
		}
		if (item_pos.indexOf(".") > -1) {
			msg = msg + "<b>Incremental</b>: "+item_pos.split(".")[1]+"<br>";
		}
	}
	msg = msg + "<br><br></div>";
	LiteGUI.showMessage( msg, {title: item_in});
}

