import logging
import time
from websocket_server import WebsocketServer

def new_client(client, server):
    server.send_message_to_all("Hey all, a new client has joined us")

def message_received(client, server, message):
    for i in range(10):
        server.send_message(client,"%s %d" % (message,i))
        time.sleep(1)

server = WebsocketServer(host='0.0.0.0', port=13254, loglevel=logging.INFO)
server.set_fn_new_client(new_client)
server.set_fn_message_received(message_received)

server.run_forever()
